Package: org.gmetrics.metric.coupling

## [Groovy] Class AbstractCouplingReferenceManager

- org.gmetrics.metric.coupling.AbstractCouplingReferenceManager

- Abstract superclass for Afferent/efferent coupling reference manager classes.

  Authors:
    Chris Mair

- - ### Field Summary

    Fields
    Modifiers | Name | Description
    --- | --- | ---
    `protected static String` | `ROOT` |
    `protected Map<String, MutableMapMetricResult>` | `metricResultMap` |
    `protected Map<String, Set<String>>` | `referencesFromPackage` |

  - ### Properties Summary

    Properties
    Type | Name and description
    --- | ---
    `Metric` | `metric`

  - ### Constructor Summary

    Constructors
    Constructor and description
    `AbstractCouplingReferenceManager (Metric metric)`

  - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `void` | `addReferencesFromPackage(String rawPackageName, Collection<String> rawPackages)`
    `` | `protected MutableMapMetricResult` | `createEmptyMetricResult()`
    `` | `MetricResult` | `getPackageMetricResult(String rawPackageName)`
    `` | `protected Set<String>` | `getReferencesFromPackage(String rawPackageName)`
    `` | `protected boolean` | `isSourcePackageOrAncestor(String packageName)`
    `` | `protected String` | `normalizePackageName(String name)`
    `` | `protected String` | `parentPackageName(String packageName)`
    `` | `protected SortedSet` | `sortPackagesWithReferencesWithParentFirst()`
    `` | `protected void` | `updateStatisticsForAncestorPackage(String packageName, int addToTotal, int addToCount)`

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class Object` | `equals, toString, hashCode, getClass, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### protected static final String ROOT

    - #### protected Map<String, MutableMapMetricResult> metricResultMap

    - #### protected Map<String, Set<String>> referencesFromPackage

  - ### Property Detail

    - #### final Metric metric

  - ### Constructor Detail

    - #### AbstractCouplingReferenceManager(Metric metric)

  - ### Method Detail

    - #### void addReferencesFromPackage(String rawPackageName, Collection<String> rawPackages)

    - #### protected MutableMapMetricResult createEmptyMetricResult()

    - #### MetricResult getPackageMetricResult(String rawPackageName)

    - #### protected Set<String> getReferencesFromPackage(String rawPackageName)

    - #### protected boolean isSourcePackageOrAncestor(String packageName)

    - #### protected String normalizePackageName(String name)

    - #### protected String parentPackageName(String packageName)

    - #### protected SortedSet sortPackagesWithReferencesWithParentFirst()

    - #### protected void updateStatisticsForAncestorPackage(String packageName, int addToTotal, int addToCount)